/**
 ****************************************************************************************************
 * @file        sys.c
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2021-10-14
 * @brief       ϵͳʼ(ʱ/жϹ/GPIOõ)
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ ̽ F407
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20211014
 * һη
 ****************************************************************************************************
 */

#include "./SYSTEM/sys/sys.h"


/**
 * @brief       жƫƵַ
 * @param       baseaddr: ַ
 * @param       offset: ƫ
 * @retval      
 */
void sys_nvic_set_vector_table(uint32_t baseaddr, uint32_t offset)
{
    /* NVICƫƼĴ,VTOR9λ,[8:0] */
    SCB->VTOR = baseaddr | (offset & (uint32_t)0xFFFFFE00);
}

/**
 * @brief       ִ: WFIָ(ִָ͹״̬, ȴжϻ)
 * @param       
 * @retval      
 */
void sys_wfi_set(void)
{
    __ASM volatile("wfi");
}

/**
 * @brief       رж(ǲfaultNMIж)
 * @param       
 * @retval      
 */
void sys_intx_disable(void)
{
    __ASM volatile("cpsid i");
}

/**
 * @brief       ж
 * @param       
 * @retval      
 */
void sys_intx_enable(void)
{
    __ASM volatile("cpsie i");
}

/**
 * @brief       ջַ
 * @note        ֺX, MDK, ʵû
 * @param       addr: ջַ
 * @retval      
 */
void sys_msr_msp(uint32_t addr)
{
    __set_MSP(addr);    /* ջַ */
}

/**
 * @brief       ģʽ
 * @param       
 * @retval      
 */
void sys_standby(void)
{
    __HAL_RCC_PWR_CLK_ENABLE();    /* ʹܵԴʱ */
    SET_BIT(PWR->CR, PWR_CR_PDDS); /* ģʽ */
}

/**
 * @brief       ϵͳλ
 * @param       
 * @retval      
 */
void sys_soft_reset(void)
{
    NVIC_SystemReset();
}

/**
 * @brief       ʱú
 * @param       plln: PLLƵϵ(PLLƵ), ȡֵΧ: 64~432.
 * @param       pllm: PLLƵPLLԤƵϵ(PLL֮ǰķƵ), ȡֵΧ: 2~63.
 * @param       pllp: PLLpƵϵ(PLL֮ķƵ), ƵΪϵͳʱ, ȡֵΧ: 2, 4, 6, 8.(4ֵ)
 * @param       pllq: PLLqƵϵ(PLL֮ķƵ), ȡֵΧ: 2~15.
 * @note
 *
 *              Fvco: VCOƵ
 *              Fsys: ϵͳʱƵ, ҲPLLpƵʱƵ
 *              Fq:   PLLqƵʱƵ
 *              Fs:   PLLʱƵ, HSI, HSE.
 *              Fvco = Fs * (plln / pllm);
 *              Fsys = Fvco / pllp = Fs * (plln / (pllm * pllp));
 *              Fq   = Fvco / pllq = Fs * (plln / (pllm * pllq));
 *
 *              ⲿΪ 8Mʱ, Ƽֵ: plln = 336, pllm = 8, pllp = 2, pllq = 7.
 *              õ:Fvco = 8 * (336 / 8) = 336Mhz
 *                   Fsys = pll_p_ck = 336 / 2 = 168Mhz
 *                   Fq   = pll_q_ck = 336 / 7 = 48Mhz
 *
 *              F407ĬҪõƵ:
 *              CPUƵ(HCLK) = pll_p_ck = 168Mhz
 *              AHB1/2/3(rcc_hclk1/2/3) = 168Mhz
 *              APB1(rcc_pclk1) = pll_p_ck / 4 = 42Mhz
 *              APB1(rcc_pclk2) = pll_p_ck / 2 = 84Mhz
 *
 * @retval      : 0, ɹ; 1, ;
 */
uint8_t sys_stm32_clock_init(uint32_t plln, uint32_t pllm, uint32_t pllp, uint32_t pllq)
{
    HAL_StatusTypeDef ret = HAL_OK;
    RCC_OscInitTypeDef rcc_osc_init = {0};
    RCC_ClkInitTypeDef rcc_clk_init = {0};

    __HAL_RCC_PWR_CLK_ENABLE();                                         /* ʹPWRʱ */

    __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);      /* õѹѹԱδƵʹ */

    /* ʹHSEѡHSEΪPLLʱԴPLL1USBʱ */
    rcc_osc_init.OscillatorType = RCC_OSCILLATORTYPE_HSE;        /* ʱԴΪHSE */
    rcc_osc_init.HSEState = RCC_HSE_ON;                          /* HSE */
    rcc_osc_init.PLL.PLLState = RCC_PLL_ON;                      /* PLL */
    rcc_osc_init.PLL.PLLSource = RCC_PLLSOURCE_HSE;              /* PLLʱԴѡHSE */
    rcc_osc_init.PLL.PLLN = plln;
    rcc_osc_init.PLL.PLLM = pllm;
    rcc_osc_init.PLL.PLLP = pllp;
    rcc_osc_init.PLL.PLLQ = pllq;
    ret = HAL_RCC_OscConfig(&rcc_osc_init);                      /* ʼRCC */
    if(ret != HAL_OK)
    {
        return 1;                                                /* ʱӳʼʧܣԼĴ */
    }

    /* ѡPLLΪϵͳʱԴHCLK,PCLK1PCLK2 */
    rcc_clk_init.ClockType = ( RCC_CLOCKTYPE_SYSCLK \
                                    | RCC_CLOCKTYPE_HCLK \
                                    | RCC_CLOCKTYPE_PCLK1 \
                                    | RCC_CLOCKTYPE_PCLK2);

    rcc_clk_init.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;         /* ϵͳʱʱԴΪPLL */
    rcc_clk_init.AHBCLKDivider = RCC_SYSCLK_DIV1;                /* AHBƵϵΪ1 */
    rcc_clk_init.APB1CLKDivider = RCC_HCLK_DIV4;                 /* APB1ƵϵΪ4 */
    rcc_clk_init.APB2CLKDivider = RCC_HCLK_DIV2;                 /* APB2ƵϵΪ2 */
    ret = HAL_RCC_ClockConfig(&rcc_clk_init, FLASH_LATENCY_5);   /* ͬʱFLASHʱΪ5WSҲ6CPU */
    if(ret != HAL_OK)
    {
        return 1;                                                /* ʱӳʼʧ */
    }
    
    /* STM32F405x/407x/415x/417x Z汾֧Ԥȡ */
    if (HAL_GetREVID() == 0x1001)
    {
        __HAL_FLASH_PREFETCH_BUFFER_ENABLE();                    /* ʹflashԤȡ */
    }
    return 0;
}


#ifdef  USE_FULL_ASSERT

/**
 * @brief       ʾʱ˺ļ
 * @param       fileָԴļ
 *              lineָļе
 * @retval      
 */
void assert_failed(uint8_t* file, uint32_t line)
{ 
    while (1)
    {
    }
}
#endif




